﻿////////////////////////////////////////////////////////////////////////////////////
// margu-NotebookInfo2 Gadget
//
// Copyright 2009 Mario Guschok (margu.eu).
//
//  This file is part of margu-NotebookInfo2.
//
//  margu-NotebookInfo2 is free software: you can redistribute it
//  and/or modify it under the terms of the GNU General Public
//  License as published by the Free Software Foundation, either
//  version 3 of the License, or (at your option) any later version.
//
//  margu-NotebookInfo2 is distributed in the hope that it will be useful,
//  but WITHOUT ANY WARRANTY; without even the implied warranty of
//  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//  GNU General Public License for more details.
//
//  You should have received a copy of the GNU General Public License
//  along with margu-NotebookInfo2.  If not, see <http://www.gnu.org/licenses/>.
//
////////////////////////////////////////////////////////////////////////////////////


//var hddletters_arr = new Array();
//var tmphddletters_arr=System.Gadget.Settings.read("hddletters_arr");
//var hddletters_arr = tmphddletters_arr.split(",")
var hddletters_arr = new Array();
hddletters_arr = System.Gadget.document.parentWindow.hddletters_arr;

var oHDD;
oHDD = GetObject("winmgmts:\\\\.\\root\\CIMV2");

var type;
var typename;

var OSlangnumber;
var OSlangname;

var tmpTable = new Array();

var DevName = new Array();
DevName[0] = "Caption";
DevName[1] = "Description";
DevName[2] = "FirmwareRevision";
DevName[3] = "Index"; // A value of 0xFF indicates that the given drive does not map to a physical drive.
DevName[4] = "InterfaceType"; // SCSI HDC IDE USB 1394
DevName[5] = "Manufacturer";
DevName[6] = "MediaLoaded";
DevName[7] = "MediaType";
DevName[8] = "Model";
DevName[9] = "Partitions";
DevName[10]= "PowerManagementSupported"; // true or false
DevName[11]= "SCSIBus";
DevName[12]= "SCSILogicalUnit";
DevName[13]= "SCSIPort";
DevName[14]= "SCSITargetId";
DevName[15]= "SerialNumber";
DevName[16]= "Size"; // in byte
DevName[17]= "Status"; // "OK" "Error" "Degraded" "Unknown" "Pred Fail" "Starting" "Stopping" "Service" "Stressed" "NonRecover" "No Contact" "Lost Comm"
DevName[18]= "StatusInfo"; // If this property does not apply to the logical device, the value 5 (Not Applicable) should be used

//DevName[0] = "Capabilities[]";
//DevName[0] = "CapabilityDescriptions[]";
//DevName[0] = "PowerManagementCapabilities[]"; // array PwrMgmCap

//DevName[0] = "Availability";
//DevName[0] = "BytesPerSector";
//DevName[0] = "CompressionMethod";
//DevName[0] = "ConfigManagerErrorCode";
//DevName[0] = "ConfigManagerUserConfig";
//DevName[0] = "CreationClassName";
//DevName[0] = "DefaultBlockSize";
//DevName[0] = "DeviceID";
//DevName[0] = "ErrorCleared";
//DevName[0] = "ErrorDescription";
//DevName[0] = "ErrorMethodology";
//DevName[0] = "InstallDate";
//DevName[0] = "LastErrorCode";
//DevName[0] = "MaxBlockSize";
//DevName[0] = "MaxMediaSize";
//DevName[0] = "MinBlockSize";
//DevName[0] = "Name";
//DevName[0] = "NeedsCleaning";
//DevName[0] = "NumberOfMediaSupported";
//DevName[0] = "PNPDeviceID";
//DevName[0] = "SectorsPerTrack";
//DevName[0] = "Signature";
//DevName[0] = "SystemCreationClassName";
//DevName[0] = "SystemName";
//DevName[0] = "TotalCylinders";
//DevName[0] = "TotalHeads";
//DevName[0] = "TotalSectors";
//DevName[0] = "TotalTracks";
//DevName[0] = "TracksPerCylinder";



function Init()
{
	hddCollect.innerText = SomeText[1];
	hddCollect.style.display="block";
	hddNav.style.display="none";

	content.style.backgroundColor = System.Gadget.Settings.read("gadgetcolourback");
	content.style.color = System.Gadget.Settings.read("gadgetcolourlabel");
	headimg.src = "/img/Flyout/hddhead.png";

	hdddriveselect.options[hdddriveselect.length] = new Option("Partitions", "0", false, true);
	hdddriveselect.options[hdddriveselect.length] = new Option("Drives", "1");

	fillpartselect('Partitions');
	changehddselect('Partitions');

	// display content and footer
	hfoot.innerText = SomeText[0];
	hddCollect.style.display="none";
	hddNav.style.display="block";
}

function fillpartselect(wert)
{
	if (wert == "Drives")
	{
		var proc;
		var query;
		var enu;

		query="SELECT * FROM Win32_DiskDrive";
		proc = oHDD.ExecQuery(query,"WQL",48);
		enu = new Enumerator(proc);

		var x=0;
		var objItem;
		var tmpoption="";

		for (; !enu.atEnd(); enu.moveNext())
		{
			objItem = enu.item();
			tmpoption = objItem.DeviceID;
			if (x == 0)
			{
				hddpartselect.options[hddpartselect.length] = new Option(tmpoption, x, false, true);
			}
			else
			{
				hddpartselect.options[hddpartselect.length] = new Option(tmpoption, x);
			}
			x++;
		}
	}
	else if (wert == "Partitions")
	{
		var x=0;
		for (i in hddletters_arr)
		{
			if (System.Shell.drive(hddletters_arr[i]))
			{
				if (System.Shell.drive(hddletters_arr[i]).isReady)
				{
					var tmpoption = "";
					tmpoption = hddletters_arr[i];
					tmpoption += ": (";
					tmpoption += System.Shell.drive(hddletters_arr[i]).volumeLabel;
					tmpoption += ")";
					if (x == 0)
					{
						hddpartselect.options[hddpartselect.length] = new Option(tmpoption, x, false, true);
					}
					else
					{
						hddpartselect.options[hddpartselect.length] = new Option(tmpoption, x);
					}
					x++;
				}
			}
		}
	}
}

function changehddselect(wert)
{
	if (wert == "Drives")
	{
		type = hdddriveselect.value;
		typename = hdddriveselect.options[type].text;
		hddpartselect.options.length = 0; // clear the select box options
		fillpartselect(typename);

		var dtype = hdddriveselect.value;
		var dtypename = hdddriveselect.options[dtype].text;
		type = hddpartselect.value;
		typename = hddpartselect.options[type].text;
		show_table(dtypename, typename);
	}
	else if (wert == "Partitions")
	{
		var dtype = hdddriveselect.value;
		var dtypename = hdddriveselect.options[dtype].text;
		type = hddpartselect.value;
		typename = hddpartselect.options[type].text;
		show_table(dtypename, typename);
	}
}

function changehddpartselect(wert)
{
	if (wert == "Drives")
	{
		var proc;
		var query;
		var enu;

		query="SELECT * FROM Win32_DiskDrive";
		proc = oHDD.ExecQuery(query,"WQL",48);
		enu = new Enumerator(proc);

		var x=0;
		var objItem;
		var tmpoption="";

		for (; !enu.atEnd(); enu.moveNext())
		{
			objItem = enu.item();
			tmpoption = objItem.DeviceID;
			if (x == 0)
			{
				hddpartselect.options[hddpartselect.length] = new Option(tmpoption, x, false, true);
			}
			else
			{
				hddpartselect.options[hddpartselect.length] = new Option(tmpoption, x);
			}
			x++;
		}
	}
	else if (wert == "Partitions")
	{
		var x=0;
		for (i in hddletters_arr)
		{
			if (System.Shell.drive(hddletters_arr[i]))
			{
				if (System.Shell.drive(hddletters_arr[i]).isReady)
				{
					var tmpoption = "";
					tmpoption = hddletters_arr[i];
					tmpoption += ": (";
					tmpoption += System.Shell.drive(hddletters_arr[i]).volumeLabel;
					tmpoption += ")";
					if (x == 0)
					{
						hddpartselect.options[hddpartselect.length] = new Option(tmpoption, x, false, true);
					}
					else
					{
						hddpartselect.options[hddpartselect.length] = new Option(tmpoption, x);
					}
					x++;
				}
			}
		}
	}
}

function show_table(dtypename, wert)
{
	if (dtypename == "Drives")
	{
		buildtable(dtypename,typename);
	}
	else if (dtypename == "Partitions")
	{
		var tmptpname = new Array();
		tmptpname = wert.split(":");
		buildtable(dtypename,tmptpname[0]);
	}
}

function buildtable(dtypename,wert)
{
	clearTable("hTabelle");

	if (dtypename == "Drives")
	{
		newTableRow(DevName.length, wert);
	}
	else if (dtypename == "Partitions")
	{
		buildtabelle(wert);
	}

}

function newTableRow(DNlen, typename)
{
	var instances;
	var query;
	var enumInstances;
	var enumProps;
	var prop;
	var oDevice;
	var pval;
	var finishloop = 0;

	query="SELECT * FROM Win32_DiskDrive";

	instances = oHDD.ExecQuery(query,"WQL",48);
	enumInstances = new Enumerator(instances);
	for ( ; !enumInstances.atEnd(); enumInstances.moveNext() )
	{
		oDevice = enumInstances.item();
		enumProps = new Enumerator(oDevice.Properties_);
		for (; !enumProps.atEnd(); enumProps.moveNext() )
		{
			prop = enumProps.item();

			if (prop.Name == "DeviceID")
			{
				if (prop.Value == typename)
				{
					finishloop = 1;
				}
			}

			for (var i=0; i<DevName.length; i++)
			{
				if (prop.Name == DevName[i])
				{
					pval="";
					if (prop.Name == "PowerManagementSupported")
					{
						if (prop.Value == true)
						{
							pval = "true";
						}
						else if (prop.Value == false)
						{
							pval = "false";
						}
						else
						{
							pval = "--";
						}

						tmpTable[i] = pval;
					}
					else if (prop.Name == "Index")
					{
						if (prop.Value == "0xFF")
						{
							pval = "drive does not map to a physical drive";
						}
						else
						{
							pval = prop.Value;
						}

						tmpTable[i] = pval;
					}
					else if (prop.Name == "StatusInfo")
					{
						if (prop.Value)
						{
							pval = StatusInfo[prop.Value];
						}
						else
						{
							pval = StatusInfo[5];
						}

						tmpTable[i] = pval;
					}
					else
					{
						if (prop.Value)
						{
							pval = prop.Value;
						}
						else
						{
							pval = "--";
						}
						if (pval.length>35) pval=pval.substr(0,35)+"...";

						tmpTable[i] = pval;
					}
				}
			}
		}
		if (finishloop == 1) { break; }
	}

	for (var i=0; i < DNlen; i++)
	{
		if (DevName[i] == "Size")
		{
			var cap1= "";

			if (tmpTable[i] > 1024000000000)
			{
				cap1 = round(tmpTable[i] / 1024 / 1024 / 1024) + " TB";
			}
			else if (tmpTable[i] > 1024000000)
			{
				cap1 = round(tmpTable[i] / 1024 / 1024) + " GB";
			}
			else if (tmpTable[i] > 1024000)
			{
				cap1 = round(tmpTable[i] / 1024) + " MB";
			}
			else
			{
				cap1 = (tmpTable[i] / 1024) + " KB";
			}


			AddRow("hTabelle", DevName[i], cap1);
		}
		else
		{
			if (DevName[i] == "PowerManagementSupported")
			{
				AddRow("hTabelle", "PwrMngmSupported", tmpTable[i]);
			}
			else
			{
				AddRow("hTabelle", DevName[i], tmpTable[i]);
			}
		}
	}
}

function buildtabelle(partition)
{
	var partLabel = System.Shell.drive(partition).volumeLabel;
	AddRow("hTabelle", "volumeLabel", partLabel);
	var partFormat = System.Shell.drive(partition).driveFormat;
	AddRow("hTabelle", "driveFormat", partFormat);
	var partType = System.Shell.drive(partition).driveType;
	if (partType == 1)
	{
		partType = "Floppy drive";
	}
	else if (partType == 2)
	{
		partType = "Removable drive";
	}
	else if (partType == 3)
	{
		partType = "Fixed drive";
	}
	else if (partType == 4)
	{
		partType = "Remote (network) drive";
	}
	else if (partType == 5)
	{
		partType = "Optical drivee";
	}
	else if (partType == 6)
	{
		partType = "RAM disk";
	}
	else
	{
		partType = "unknown disk type";
	}
	AddRow("hTabelle", "driveType", partType);

	var partSize = System.Shell.drive(partition).totalSize;
	var tmppartSize = partSize;
	if (partSize > 1024000)
	{
		partSize = round(partSize / 1024) + " TB";
	}
	else if (partSize > 1024)
	{
		partSize = round(partSize) + " GB";
	}
	else
	{
		partSize = partSize + " MB";
	}
	AddRow("hTabelle", "totalSize", partSize);

//	var partFree = System.Shell.drive(partition).freeSpace;
	var partFree = System.Shell.drive(partition).totalFreeSpace;
	var tmppartFree = partFree;
	if (partFree > 1024000)
	{
		partFree = round(partFree / 1024) + " TB";
	}
	else if (partFree > 1024)
	{
		partFree = round(partFree) + " GB";
	}
	else
	{
		partFree = partFree + " MB";
	}
	AddRow("hTabelle", "freeSpace", partFree);

	var partUsed = tmppartSize - tmppartFree;
	if (partUsed > 1024000)
	{
		partUsed = round(partUsed / 1024) + " TB";
	}
	else if (partUsed > 1024)
	{
		partUsed = round(partUsed) + " GB";
	}
	else
	{
		partUsed = partUsed + " MB";
	}
	AddRow("hTabelle", "UsedSpace", partUsed);

}


function AddRow(tab, content, content2)
{
	var TabElem = document.getElementById(tab);
	var NewRow = document.createElement("tr");
	if(NewRow.style.display)
	{
		NewRow.style.display="table-row";
	}

	var NewRowContent = document.createElement("td");
	if(NewRowContent.style.display)
	{
		NewRowContent.style.display="table-cell";
		NewRowContent.style.width="100";
		NewRowContent.style.whiteSpace="normal";
	}
	var NewRowContent_Text = document.createTextNode(content);
	NewRowContent.appendChild(NewRowContent_Text);

	var NewRowContent2 = document.createElement("td");
	if(NewRowContent2.style.display)
	{
		NewRowContent2.style.display="table-cell";
		NewRowContent2.style.width="240";
		NewRowContent2.style.whiteSpace="normal";
	}
	var NewRowContent2_Text = document.createTextNode(content2);
	NewRowContent2.appendChild(NewRowContent2_Text);

	NewRow.appendChild(NewRowContent);
	NewRow.appendChild(NewRowContent2);

	TabElem.getElementsByTagName("tbody")[0].appendChild(NewRow);

}

function clearTable(wert)
{
	if (wert == "hTable")
	{
		var rowsnum = hTable.rows.length;
		for (var i = 0; i < rowsnum; rowsnum--)
		{
			hTable.deleteRow(i);
		}
	}
	else if (wert == "hTabelle")
	{
		var rowsnum = hTabelle.rows.length;
		for (var i = 0; i < rowsnum; rowsnum--)
		{
			hTabelle.deleteRow(i);
		}
	}
}

function round(x) {
	var k = (x / 1024).toString();
	k += (k.indexOf('.') == -1)? '.00' : '00';
	var p = k.indexOf('.'), m = k.indexOf('-.');

	var f;
	var l = "0";
	for (var i = 0;i < LangComma.length; i++)
	{
		if (OSlangname == LangComma[i])
		{
			l = "1";
		}
	}

	if (l == "1")
	{
		f = (p == 0 || m == 0)? '0,' : ','; // comma as digit grouping symbol
	}
	else
	{
		f = (p == 0 || m == 0)? '0.' : '.'; // period as digit grouping symbol
	}
	return k.substring(0, p) + f + k.substring(p+1, p+3);
}


