﻿////////////////////////////////////////////////////////////////////////////////////
// margu-NotebookInfo2 Gadget
//
// Copyright 2009 Mario Guschok (margu.eu).
//
//  This file is part of margu-NotebookInfo2.
//
//  margu-NotebookInfo2 is free software: you can redistribute it
//  and/or modify it under the terms of the GNU General Public
//  License as published by the Free Software Foundation, either
//  version 3 of the License, or (at your option) any later version.
//
//  margu-NotebookInfo2 is distributed in the hope that it will be useful,
//  but WITHOUT ANY WARRANTY; without even the implied warranty of
//  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//  GNU General Public License for more details.
//
//  You should have received a copy of the GNU General Public License
//  along with margu-NotebookInfo2.  If not, see <http://www.gnu.org/licenses/>.
//
////////////////////////////////////////////////////////////////////////////////////

//var oShell = new ActiveXObject("WScript.Shell");
//var oCPU = GetObject("WinMgmts:").InstancesOf ("CIM_Processor");

var oCPU;
var Zeile = "0";
var firstrun = 1;

function Init()
{
	cpuCollect.innerText = SomeText[1];
	cpuCollect.style.display="block";
	cinfo.style.display="none";

	content.style.backgroundColor = System.Gadget.Settings.read("gadgetcolourback");
	content.style.color = System.Gadget.Settings.read("gadgetcolourlabel");

	headimg.src = "/img/Flyout/cpuhead.png";
    setInterval(onTimer,2000);
}

function onTimer()
{
	if (firstrun == "1")
	{
	    firstrun = "0";
	}
	else
	{
		GetCPUStatus();
	    firstrun = "0";
	}
}

// --------------------------------------------------------------------
// Get the machine cpu information.
// --------------------------------------------------------------------
function GetCPUStatus()
{
	if (firstrun == 0)
	{
		clearTable("Tabelle");
		Zeile = 0;
	}
	oCPU = GetObject("WinMgmts:").InstancesOf ("Win32_Processor");

	ShowDevices(oCPU, "CPU", "Manufacturer");
	ShowDevices(oCPU, "CPU", "Name");
	ShowDevices(oCPU, "CPU", "Family");
	ShowDevices(oCPU, "CPU", "Description");
	ShowDevices(oCPU, "CPU", "MaxClockSpeed");
	ShowDevices(oCPU, "CPU", "CurrentClockSpeed");
	ShowDevices(oCPU, "CPU", "ExtClock");
	ShowDevices(oCPU, "CPU", "NumberOfCores");
	ShowDevices(oCPU, "CPU", "NumberOfLogicalProcessors");
	ShowDevices(oCPU, "CPU", "L2CacheSize");
	ShowDevices(oCPU, "CPU", "L2CacheSpeed");
	ShowDevices(oCPU, "CPU", "AddressWidth");
	ShowDevices(oCPU, "CPU", "DataWidth");
	ShowDevices(oCPU, "CPU", "Architecture");
	ShowDevices(oCPU, "CPU", "VoltageCaps");
	ShowDevices(oCPU, "CPU", "SocketDesignation");
	ShowDevices(oCPU, "CPU", "UpgradeMethod");

	inote.innerText = SomeText[0];

	cpuCollect.style.display="none";
	cinfo.style.display="block";
}

function ShowDevices(instances, className, Name)
{
	var enumInstances = new Enumerator(instances);
	for ( ; !enumInstances.atEnd(); enumInstances.moveNext() )
	{
		var oDevice = enumInstances.item();
		var enumProps = new Enumerator(oDevice.Properties_);
		for (; !enumProps.atEnd(); enumProps.moveNext() )
		{
			var prop = enumProps.item();
			if (prop.Name == Name)
			{
				if (Name == "Manufacturer")
				{
					newTableRow(prop.Name, prop.Value);
				}
				else if (Name == "Name" && className == "CPU")
				{
					newTableRow(prop.Name, prop.Value);
				}
				else if (Name == "Family")
				{
					newTableRow(prop.Name, Fam[prop.Value]);
				}
				else if (Name == "Description")
				{
					newTableRow(prop.Name, prop.Value);
				}
				else if (Name == "MaxClockSpeed")
				{
					newTableRow(prop.Name, prop.Value+"MHz");
				}
				else if (Name == "CurrentClockSpeed")
				{
					newTableRow(prop.Name, prop.Value+"MHz");
				}
				else if (Name == "ExtClock")
				{
					if (prop.Value != null)
					{
						newTableRow(prop.Name, prop.Value+"MHz");
					}
					else
					{
						newTableRow(prop.Name, "--");
					}
				}
				else if (Name == "NumberOfCores")
				{
					newTableRow(prop.Name, prop.Value);
				}
				else if (Name == "NumberOfLogicalProcessors")
				{
					newTableRow("LogicalProcessors", prop.Value);
				}
				else if (Name == "L2CacheSize")
				{
					if (prop.Value != null)
					{
						newTableRow(prop.Name, prop.Value+"kb");
					}
					else
					{
						newTableRow(prop.Name, "--");
					}
				}
				else if (Name == "L2CacheSpeed")
				{
					if (prop.Value != null)
					{
						newTableRow(prop.Name, prop.Value+"MHz");
					}
					else
					{
						newTableRow(prop.Name, "--");
					}
				}
				else if (Name == "AddressWidth")
				{
					newTableRow(prop.Name, prop.Value+"bit");
				}
				else if (Name == "DataWidth")
				{
					newTableRow(prop.Name, prop.Value+"bit");
				}
				else if (Name == "Architecture")
				{
					newTableRow(prop.Name, Arch[prop.Value]);
				}
				else if (Name == "VoltageCaps")
				{
					if (prop.Value != null)
					{
						newTableRow(prop.Name, Volt[prop.Value]);
					}
					else
					{
						newTableRow(prop.Name, "--");
					}
				}
				else if (Name == "SocketDesignation")
				{
					newTableRow(prop.Name, prop.Value);
				}
				else if (Name == "UpgradeMethod")
				{
					if (prop.Value != null)
					{
						newTableRow(prop.Name, UpgM[prop.Value]);
					}
					else
					{
						newTableRow(prop.Name, "--");
					}
				}
			}
		}
//		oShell.Popup(msg, 0, className + " Device", 0);
	}
}

function newTableRow(name, value)
{
	var TR = Tabelle.insertRow();
	var TD1 = document.createElement("td");
	var TD1text = document.createTextNode(name);
	TD1.appendChild(TD1text);
	var TD2 = document.createElement("td");
	var TD2text = document.createTextNode(value);
	TD2.appendChild(TD2text);
	TR.appendChild(TD1);
	TR.appendChild(TD2);
	Zeile ++;
}

function clearTable(wert)
{
	if (wert == "Tabelle")
	{
		var rowsnum = Tabelle.rows.length;
		for (var i = 0; i < rowsnum; rowsnum--)
		{
			Tabelle.deleteRow(i);
		}
	}
}

