﻿////////////////////////////////////////////////////////////////////////////////////
// margu-NotebookInfo2 Gadget
//
// Copyright 2009 Mario Guschok (margu.eu).
//
//  This file is part of margu-NotebookInfo2.
//
//  margu-NotebookInfo2 is free software: you can redistribute it
//  and/or modify it under the terms of the GNU General Public
//  License as published by the Free Software Foundation, either
//  version 3 of the License, or (at your option) any later version.
//
//  margu-NotebookInfo2 is distributed in the hope that it will be useful,
//  but WITHOUT ANY WARRANTY; without even the implied warranty of
//  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//  GNU General Public License for more details.
//
//  You should have received a copy of the GNU General Public License
//  along with margu-NotebookInfo2.  If not, see <http://www.gnu.org/licenses/>.
//
////////////////////////////////////////////////////////////////////////////////////

System.Gadget.onSettingsClosing = SettingsClosing;

var DisplayInGHz, DisplayDualCore, DisplayDualCPU, AutoUpdate, Homepage, altbcal, ShowUpt;
var ShowCPU, ShowNet, ShowBat, ShowHDD, ShowRAM, ShowDualCoreUsage, PlayBatBeep, HideBG;
var DisplayAMPM, DisplayAnimation,timeZoneIndex,ShowCal,DisplayKW,classicWiFi, ShowUptSec;
var DisplayClock2, physicalCPU, logicalCPU, currentCores, CalAppName, ShowNetUsage;

var gname = System.Gadget.name;
var tv = System.Gadget.version;
var gp = System.Gadget.path;
var Homepage = System.Gadget.document.parentWindow.Homepage;
var versionjsfile = System.Gadget.document.parentWindow.versionjsfile;

var WMI = GetObject("winmgmts:\\\\.\\root\\CIMV2");
var interfaceCount;
var InterfaceArray = new Array();
InterfaceArray[0] = "none";
var interfaceCount=0;
var numofcores = System.Machine.CPUs.count;
var numofmods = System.Gadget.document.parentWindow.numofmods;
var numofaktmods = System.Gadget.Settings.read("numofaktmods");
var hddaktcnt =System.Gadget.document.parentWindow.hddaktcnt;
var hddletters_arr = new Array();
hddletters_arr = System.Gadget.document.parentWindow.hddletters_arr;
var hddboxes_arr = new Array();
var modpositions = new Array();
var newmodpositions = new Array();
var allmods = new Array();
var aktivemods = new Array();
var modpositionsstring;

var divColorPicker = false;
var divColorPicker_active_tab = false;
var cdivColorPicker_form_field = false;
var divColorPicker_active_input = false;

var settfirstrun;

function onLoad()
{
	settfirstrun = System.Gadget.Settings.read("settfirstrun");
	initSettings();
}

function onUnload()
{
	SettingsClosing;
}

function initSettings()
{
	InterfaceArray[0] = SomeText[1];
	wintfselect.options[0] = new Option(InterfaceArray[0], 0);
	intfselect.options[0] = new Option(InterfaceArray[0], 0);

	setTimeout(NICinitialize, 1000);
//	clearTimeout(NICinitialize);

	fillDateVars();

	LoadSettings();

	checkupdate();
}

function NICinitialize()
{
	var proc;
	var query;
	query="SELECT * FROM Win32_NetworkAdapter WHERE AdapterType='Ethernet 802.3'";
	proc = WMI.ExecQuery(query,"WQL",48);
	var i = 1;
	var enumInstances = new Enumerator(proc);
	for ( ; !enumInstances.atEnd(); enumInstances.moveNext() )
	{
		var oDevice = enumInstances.item();
		var enumProps = new Enumerator(oDevice.Properties_);
		for (; !enumProps.atEnd(); enumProps.moveNext() )
		{
			var prop = enumProps.item();
			if (prop.Name == "Name")
			{
				InterfaceArray[i] = prop.Value;
				i++;
			}
		}
	}
	interfaceCount = i;

	if ((settfirstrun != "notset") && System.Gadget.Settings.read("wintfselect") && System.Gadget.Settings.read("intfselect"))
	{
		var chknic = checkNIC();
		if (chknic != true)
		{
			NICinitialize();
		}
		else
		{
			InterfaceArray[0] = SettText[5];
			wintfselect.options[wintfselect.length - 1] = null;
			intfselect.options[intfselect.length - 1] = null;
			fillInterfaceCombo();
			wintfselect.value = System.Gadget.Settings.read("wintfselect");
			intfselect.value = System.Gadget.Settings.read("intfselect");
		}
	}
	else
	{
		InterfaceArray[0] = SettText[5];
		wintfselect.options[wintfselect.length - 1] = null;
		intfselect.options[intfselect.length - 1] = null;
		fillInterfaceCombo();
		wintfselect.value = System.Gadget.Settings.read("wintfselect");
		intfselect.value = System.Gadget.Settings.read("intfselect");
	}

	clearTimeout(NICinitialize);
}

function checkNIC()
{
	if (InterfaceArray[System.Gadget.Settings.read("wintfselect")] != System.Gadget.Settings.read("wintfname"))
	{
		return false;
	}
	else if (InterfaceArray[System.Gadget.Settings.read("intfselect")] != System.Gadget.Settings.read("intfname"))
	{
		return false;
	}
	else
	{
		return true;
	}
}

function LoadSettings()
{
	settHDDBtn.value = "Main" + " / " + SettText[46] + " / other Settings";
	cpuclocktext1.innerText = SettText[0];
	cpuclocktext2.innerText = SettText[13];
	checktext.innerText = SettText[1];
	bcaltext.innerText = SettText[2];
	hddtext.innerText = SettText[47];
	ampmtext.innerText = SettText[23];
	animatetext.innerText = SettText[25];
	clocknametext.innerText = SettText[28];
	clockdnametext.innerText = SettText[28];
	currentDFtext.innerText = SettText[24];
	aupdatetext.innerText = UpdText[10];
	homepagetext.innerText = UpdText[11];
	mupdatebutton.value = UpdText[12];
	intfinfotext.innerText = SettText[6];
	wintftext.innerText = SettText[3];
	intftext.innerText = SettText[4];
	modinfotext.innerText = SettText[7];
	cpumodtext.innerText = SettText[8];
	netmodtext.innerText = SettText[9];
	batmodtext.innerText = SettText[10];
	batbeeptext.innerText = SettText[17];
	hddmodtext.innerText = SettText[46];
	rammodtext.innerText = SettText[12];
	netusagetext.innerText = SettText[48];
	dualcoreusetext.innerText = SettText[14];
	uptmodtext.innerText = SettText[52];
	pwrmodtext.innerText = SettText[15];
	clkmodtext.innerText = SettText[22];
	calmodtext.innerText = wmtttext[18];
	wifistyletext.innerText = SettText[41];
	prvw_text.innerText = SettText[18];
	themetext.value = SettText[16];
	themeundobtn.value = SettText[20];
	themedefaultbtn.value = SettText[21];
	currTZtext.innerText = SettText[26];
	fonttext.innerText = SettText[29];
	transbacktext.innerText = SettText[30];
	firstwdaytext.innerText = SettText[32];
	kwtext.innerText = SettText[33];
	kwshowtext.innerText = SettText[36];
	clk2onofftext.innerText = SettText[42];
	currTZtext2.innerText = SettText[26];
	clock2nametext.innerText = SettText[43];
	settClockCalBtn.value = SettText[22] + " / " + wmtttext[18];
	CalApptext.innerText = SettText[44];
	CalAppargstext.innerText = SettText[45];
	CalAppbtn.value = SettText[31];
	savesettbtn.value = SettText[55];
	restoresettbtn.value = SettText[56];
	saverestoresettingstext.innerText = SettText[57];
	uptsecondstext.innerText = SettText[58];

	gadgetcolourback = System.Gadget.Settings.read("gadgetcolourback");
	gadgetcolourlabel = System.Gadget.Settings.read("gadgetcolourlabel");
	gadgetcolournormal = System.Gadget.Settings.read("gadgetcolournormal");
	gadgetcolourwarn = System.Gadget.Settings.read("gadgetcolourwarn");
	gadgetcolourcritical = System.Gadget.Settings.read("gadgetcolourcritical");

	Content.style.backgroundColor = gadgetcolourback;
	Content.style.color = gadgetcolourlabel;

	aktualVersion.innerText = "You use " + gname + " Version " + tv;
	homepageinfo.innerText = "Help and information about this gadget you'll find at";
	homepagelinkinfo.innerHTML = "<a href=\"" + Homepage + "\">" + Homepage + "</a> (german and english)";

	DisplayDualCore=System.Gadget.Settings.read("dispdualcore");
	DisplayDualCPU=System.Gadget.Settings.read("dispdualcpu");
	physicalCPU=System.Gadget.Settings.read("physicalcpu");
	logicalCPU=System.Gadget.Settings.read("logicalcpu");
	currentCores=System.Gadget.Settings.read("currentCores");
	currentNetusage=System.Gadget.Settings.read("currentNetusage");

	uptmodheight = System.Gadget.Settings.read("uptmodheight");
	cpumodheight = System.Gadget.Settings.read("cpumodheight");
	hddmodheight = System.Gadget.Settings.read("hddmodheight");
	rammodheight = System.Gadget.Settings.read("rammodheight");
	netmodheight = System.Gadget.Settings.read("netmodheight");
	batmodheight = System.Gadget.Settings.read("batmodheight");
	pwrmodheight = System.Gadget.Settings.read("pwrmodheight");
	clkmodheight = System.Gadget.Settings.read("clkmodheight");
	clk2modheight = System.Gadget.Settings.read("clk2modheight");
	singlehddusageheight = System.Gadget.Settings.read("singlehddusageheight");
	singlenetusageheight = System.Gadget.Settings.read("singlenetusageheight");
	dualnetusageheight = System.Gadget.Settings.read("dualnetusageheight");
	singleusageheight = System.Gadget.Settings.read("singleusageheight");
	clkmodheightsum = System.Gadget.Settings.read("clkmodheightsum");
	hddmodheightsum = System.Gadget.Settings.read("hddmodheightsum");
	rammodheightsum = System.Gadget.Settings.read("rammodheightsum");
	calmodheight = System.Gadget.Settings.read("calmodheight");
	gadgetheightcontainer = System.Gadget.Settings.read("gadgetheightcontainer");
	gadgetheightmods = System.Gadget.Settings.read("gadgetheightmods");
	gadgetheightsum = System.Gadget.Settings.read("gadgetheightsum");

	currentDF = System.Gadget.Settings.read("currentDF");
	DisplayKW=System.Gadget.Settings.read("kwselect");
	DisplayKWshow=System.Gadget.Settings.read("kwshowselect");
	Homepage=System.Gadget.Settings.read("homepage");
	HideBG=System.Gadget.Settings.read("transbackbox");
	if(HideBG==0)
	{
		transbackbox.checked=false;
	}
	else
	{
		transbackbox.checked=true;
	}

	classicWiFi=System.Gadget.Settings.read("classicWiFi");
	if(classicWiFi==0)
	{
		wifistylebox.checked=false;
	}
	else
	{
		wifistylebox.checked=true;
	}

	if (settfirstrun=="notset")
	{
		cpuclockbox1.checked=false;
		cpuclockbox2.checked=true;
	}
	else if (DisplayDualCPU==true && DisplayDualCore==false)
	{
		cpuclockbox1.checked=true;
		cpuclockbox2.checked=false;
	}
	else
	{
		cpuclockbox1.checked=false;
		cpuclockbox2.checked=true;
	}

	if (physicalCPU == "1")
	{
		cpuclockbox1.disabled=true;
		cpuclocktext1.style.color="grey";
	}
	else
	{
		cpuclockbox1.disabled=false;
		cpuclocktext1.style.color=gadgetcolourlabel;
	}

	fillNetUsageCombo();
	if (currentNetusage)
	{
		netusageselect.value = currentNetusage;
	}
	else
	{
		netusageselect.value = 2;
	}

	netusagebox.disabled=false;
	netusagetext.style.color=gadgetcolourlabel;
	ShowNetUsage=System.Gadget.Settings.read("netusagebox");
	if (settfirstrun=="notset")
	{
		netusagebox.checked=false;
		netusageselect.disabled=false;
	}
	else if(ShowNetUsage==0)
	{
		netusagebox.checked=false;
		netusageselect.disabled=true;
	}
	else
	{
		netusagebox.checked=true;
		netusageselect.disabled=false;
	}

	if (logicalCPU == "1")
	{
		cpuclockbox2.disabled=true;
		cpuclocktext2.style.color="grey";
		dualcoreusebox.checked=false;
		dualcoreusebox.disabled=true;
		dualcoreusetext.style.color="grey";
		numofcoresselect.disabled=true;
	}
	else
	{
		cpuclockbox2.disabled=false;
		cpuclocktext2.style.color=gadgetcolourlabel;
		dualcoreusebox.disabled=false;
		dualcoreusetext.style.color=gadgetcolourlabel;
		ShowDualCoreUsage=System.Gadget.Settings.read("dualcoreusebox");
		if (settfirstrun=="notset")
		{
			dualcoreusebox.checked=true;
			numofcoresselect.disabled=false;
		}
		else if(ShowDualCoreUsage==0)
		{
			dualcoreusebox.checked=false;
			numofcoresselect.disabled=true;
		}
		else
		{
			dualcoreusebox.checked=true;
			numofcoresselect.disabled=false;
		}
	}

	DisplayInGHz=System.Gadget.Settings.read("dispinghz");
	if(DisplayInGHz==0)
	{
		cpubox.checked=false;
	}
	else
	{
		cpubox.checked=true;
	}

	DisplayAMPM=System.Gadget.Settings.read("ampmbox");
	if(DisplayAMPM==false)
	{
		ampmbox.checked=false;
	}
	else
	{
		ampmbox.checked=true;
	}

	DisplayAnimation=System.Gadget.Settings.read("animatebox");
	if(DisplayAnimation==false)
	{
		animatebox.checked=false;
	}
	else
	{
		animatebox.checked=true;
	}

	DisplayClock2=System.Gadget.Settings.read("clk2onoffbox");
	if(DisplayClock2==false)
	{
		clk2onoffbox.checked=false;
	}
	else
	{
		clk2onoffbox.checked=true;
	}

	altbcal=System.Gadget.Settings.read("altbcal");
	if(altbcal==0)
	{
		bcalcbox.checked=false;
	}
	else
	{
		bcalcbox.checked=true;
	}

	var tmp_hddboxes_arr = "";
	var tmp_hddboxes_arr = System.Gadget.Settings.read("hddboxes_arr");
	hddboxes_arr = tmp_hddboxes_arr.split(",")
	var temp_boxesdiv1 = "";

	temp_boxesdiv1 += "<form action=\"\" id=\"hddForm\" name=\"hddForm\"><br>";
	for (var i in hddletters_arr)
	{
		temp_boxesdiv1 += "<input type=\"checkbox\" name=\"hddCheckbox\" id=\"hdd";
		temp_boxesdiv1 += hddletters_arr[i] + "box\"";
		if (hddboxes_arr[i] != "false")
		{
			temp_boxesdiv1 += " checked ";
		}
		temp_boxesdiv1 += "/>";
		temp_boxesdiv1 += hddletters_arr[i] + " ";
	}
	temp_boxesdiv1 += "<br><br><input type=\"button\" class=\"Button\" id=\"hddBtnall\"";
	temp_boxesdiv1 += " onclick=\"SetAllCheckBoxes('hddForm', 'hddCheckbox', true);\"";
	temp_boxesdiv1 += " value=\"" + SettText[53] + "\">&nbsp;&nbsp;";
	temp_boxesdiv1 += "<input type=\"button\" class=\"Button\" id=\"hddBtnnone\"";
	temp_boxesdiv1 += " onclick=\"SetAllCheckBoxes('hddForm', 'hddCheckbox', false);\"";
	temp_boxesdiv1 += " value=\"" + SettText[54] + "\">";
	temp_boxesdiv1 += "</form>";

	hddboxes1.innerHTML = temp_boxesdiv1;

	AutoUpdate=System.Gadget.Settings.read("autoupdate");
	if(AutoUpdate==0)
	{
		aupdatebox.checked=false;
	}
	else
	{
		aupdatebox.checked=true;
	}

	PlayBatBeep=System.Gadget.Settings.read("batbeepbox");
	if (settfirstrun=="notset")
	{
		batbeepbox.checked=true;
	}
	else if(PlayBatBeep==0)
	{
		batbeepbox.checked=false;
	}
	else
	{
		batbeepbox.checked=true;
	}

	loadModSettings();

	homepageurl.innerHTML="<a href=\"" + Homepage + "\">" + Homepage + "</a>";

//	numofcoresselect.options[0] = new Option(SettText[5], 0);
	fillCoresCombo();
	if (currentCores)
	{
		numofcoresselect.value = currentCores;
	}
	else
	{
		numofcoresselect.value = 2;
	}

	divSettings.style.display="block";
	divSettings2.style.display="none";
	divLayout.style.display="none";
	divUpdate.style.display="none";
	divInformation.style.display="none";

	divCP.style.display = "none";
	modsettings.style.display = "block";
	mainSettings.style.display = "block";
	hddSettings.style.display = "none";
	clockSettings.style.display = "block";
	calsettings.style.display = "none";

	fillFontCombo();
	fontselect.value = System.Gadget.Settings.read("fontselect");

	prev_text_div.style.fontFamily = mniFonts[System.Gadget.Settings.read("fontselect")];

	dateformatArray[0] = SettText[5];
	currentDFselect.options[0] = new Option(dateformatArray[0], 0);
	fillDFCombo();
	currentDFselect.value = currentDF;

	fillTZcombo();

	with (currTZselect)
	{
		value = getValidTimeZone(System.Gadget.Settings.read("timeZoneIndex"));
		title = options[selectedIndex].text;
	}

	with (currTZselect2)
	{
		value = getValidTimeZone(System.Gadget.Settings.read("timeZoneIndex2"));
		title = options[selectedIndex].text;
	}

	clocknameinput.value = System.Gadget.Settings.read("clocknameinput");
	clockdnameinput.value = System.Gadget.Settings.read("clockdnameinput");
	clock2nameinput.value = System.Gadget.Settings.read("clock2nameinput");

	fillfirstwdaycombo();
	firstwdayselect.value = System.Gadget.Settings.read("firstwdayselect");

	fillKWcombo();
	kwselect.value = DisplayKW;

	fillKWshowcombo();
	kwshowselect.value = DisplayKWshow;

	CalApppath.value = System.Gadget.Settings.read("CalApppath");
	CalAppargs.value = System.Gadget.Settings.read("CalAppargs");
	CalAppName = System.Gadget.Settings.read("CalAppName");

	inittheme();

	document.getElementsByName("themeinbck")[0].value = gadgetcolourback;
	document.getElementsByName("themeintxt1")[0].value = gadgetcolourlabel;
	document.getElementsByName("themeintxt2")[0].value = gadgetcolournormal;
	document.getElementsByName("themeintxt3")[0].value = gadgetcolourwarn;
	document.getElementsByName("themeintxt4")[0].value = gadgetcolourcritical;

	prev_text_div.style.backgroundColor = gadgetcolourback;
	prev_text_label.style.color = gadgetcolourlabel;
	prev_text_normal.style.color = gadgetcolournormal;
	prev_text_warn.style.color = gadgetcolourwarn;
	prev_text_critical.style.color = gadgetcolourcritical;

	changefont();

	onchangeaction("cpumodbox");
	onchangeaction("uptmodbox");
	onchangeaction("batmodbox");
	onchangeaction("netmodbox");
	onchangeaction("netusagebox");
	onchangeaction("animatebox");
	onchangeaction("clockdname");
	onchangeaction("clkmodbox");
	onchangeaction("rammodbox");
	onchangeaction("hddmodbox");
	onchangeaction("transbackbox");
	onchangeaction("calmodbox");
	onchangeaction("clk2onoffbox");
}

function SetAllCheckBoxes(FormName, FieldName, CheckValue)
{
	if(!document.forms[FormName])
		return;
	var objCheckBoxes = document.forms[FormName].elements[FieldName];
	if(!objCheckBoxes)
		return;
	var countCheckBoxes = objCheckBoxes.length;
	if(!countCheckBoxes)
		objCheckBoxes.checked = CheckValue;
	else
		// set the check value for all check boxes
		for(var i = 0; i < countCheckBoxes; i++)
			objCheckBoxes[i].checked = CheckValue;
}

function loadModSettings()
{
	var x = 0;
	var x2 = 0;
	ShowCPU=System.Gadget.Settings.read("cpumodbox");
	allmods[x2] = "cpu";
	x2++;
	if (settfirstrun=="notset")
	{
		cpumodbox.checked=true;
		aktivemods[x] = "cpu";
		x++;
	}
	else if (ShowCPU==0)
	{
		cpumodbox.checked=false;
	}
	else
	{
		cpumodbox.checked=true;
		aktivemods[x] = "cpu";
		x++;
	}

	ShowNet=System.Gadget.Settings.read("netmodbox");
	allmods[x2] = "net";
	x2++;
	if (settfirstrun=="notset")
	{
		netmodbox.checked=true;
		aktivemods[x] = "net";
		x++;
	}
	else if(ShowNet==0)
	{
		netmodbox.checked=false;
	}
	else
	{
		netmodbox.checked=true;
		aktivemods[x] = "net";
		x++;
	}

	ShowBat=System.Gadget.Settings.read("batmodbox");
	allmods[x2] = "bat";
	x2++;
	if (settfirstrun=="notset")
	{
		batmodbox.checked=true;
		aktivemods[x] = "bat";
		x++;
	}
	else if(ShowBat==0)
	{
		batmodbox.checked=false;
	}
	else
	{
		batmodbox.checked=true;
		aktivemods[x] = "bat";
		x++;
	}

	ShowUpt=System.Gadget.Settings.read("uptmodbox");
	ShowUptSec=System.Gadget.Settings.read("uptsecondsbox");
	if(ShowUptSec==0)
	{
		uptsecondsbox.checked=false;
	}
	else
	{
		uptsecondsbox.checked=true;
	}
	allmods[x2] = "upt";
	x2++;
	if (settfirstrun=="notset")
	{
		uptmodbox.checked=false;
	}
	else if(ShowUpt==0)
	{
		uptmodbox.checked=false;
	}
	else
	{
		uptmodbox.checked=true;
		aktivemods[x] = "upt";
		x++;
	}

	ShowClk=System.Gadget.Settings.read("clkmodbox");
	allmods[x2] = "clk";
	x2++;
	if (settfirstrun=="notset")
	{
		clkmodbox.checked=false;
	}
	else if(ShowClk==0)
	{
		clkmodbox.checked=false;
	}
	else
	{
		clkmodbox.checked=true;
		aktivemods[x] = "clk";
		x++;
	}

	ShowCal=System.Gadget.Settings.read("calmodbox");
	allmods[x2] = "cal";
	x2++;
	if (settfirstrun=="notset")
	{
		calmodbox.checked=false;
	}
	else if(ShowCal==0)
	{
		calmodbox.checked=false;
	}
	else
	{
		calmodbox.checked=true;
		aktivemods[x] = "cal";
		x++;
	}

	ShowPwr=System.Gadget.Settings.read("pwrmodbox");
	allmods[x2] = "pwr";
	x2++;
	if (settfirstrun=="notset")
	{
		pwrmodbox.checked=false;
	}
	else if(ShowPwr==0)
	{
		pwrmodbox.checked=false;
	}
	else
	{
		pwrmodbox.checked=true;
		aktivemods[x] = "pwr";
		x++;
	}

	ShowRAM=System.Gadget.Settings.read("rammodbox");
	allmods[x2] = "ram";
	x2++;
	if ((settfirstrun=="notset") || (ShowRAM==0))
	{
		rammodbox.checked=false;
		dualcoreusebox.disabled=true;
		dualcoreusetext.style.color="grey";
	}
	else
	{
		rammodbox.checked=true;
		dualcoreusebox.disabled=false;
		dualcoreusetext.style.color=gadgetcolourlabel;
		aktivemods[x] = "ram";
		x++;
	}

	ShowHDD=System.Gadget.Settings.read("hddmodbox");
	allmods[x2] = "hdd";
	x2++;
	if (settfirstrun=="notset")
	{
		hddmodbox.checked=false;
	}
	else if(ShowHDD==0)
	{
		hddmodbox.checked=false;
	}
	else
	{
		hddmodbox.checked=true;
		aktivemods[x] = "hdd";
		x++;
	}
}

function selectfile(wert,content)
{
	if (wert == "calapp")
	{
		var strFilter = "Program files:*.exe;*.com;*.cmd;*.bat:Any:*::";
		var strInitDir = System.Environment.getEnvironmentVariable("PROGRAMFILES"); // + "\\Media\\";
		var strFileInit = "";
		var CalApp = "";

		if (CalApppath.value != "")
		{
			var tmp1 = CalApppath.value;
			var tmp2 = "";
			var tmparr = tmp1.split("/");
			for (var i=0; i<tmparr.length;i++)
			{
				tmp2 += tmparr[i];
			}
			strInitDir = tmp2;
		}

		CalApp = System.Shell.chooseFile(true, strFilter, strInitDir, strFileInit);
		if (CalApp != null)
		{
			CalApppath.value = CalApp.path;
			var tmparr = CalApp.path.split("\\");
			CalAppName = tmparr[tmparr.length-1].split(".")[0];
		}
	}

	if (wert == "restoresett")
	{
		var strFilter = "Text File:*.txt:Any:*::";
		var strInitDir = System.Environment.getEnvironmentVariable("HOMEPATH");
		var strFileInit = "";
		var GadSettFile = System.Shell.chooseFile(true, strFilter, strInitDir, strFileInit);
		if (GadSettFile.path != null)
		{
//			alert(GadSettFile.path);

			var ForReading = 1, ForWriting = 2, ForAppending = 8;
			var TristateUseDefault = -2, TristateTrue = -1, TristateFalse = 0;
			var fso = new ActiveXObject("Scripting.FileSystemObject");
			var filename = GadSettFile.path;
			var fileObj = fso.GetFile(filename);

			// Open a text stream for input.
			ts = fileObj.OpenAsTextStream(ForReading, TristateUseDefault);

			// Read from the text stream and display the results.
			while (!ts.AtEndOfStream) {
				var textLine = ts.ReadLine();
			}
			ts.Close();

			var textlinearray = textLine.split("||");
			for (var i=0; i<textlinearray.length; i=i+2)
			{
				// fix the uppercase for True and False
				if (textlinearray[i+1] == "true") { textlinearray[i+1] = "True"; }
				if (textlinearray[i+1] == "false") { textlinearray[i+1] = "False"; }

				if (textlinearray[i] == "numofaktmods")
				{
					numofaktmods = textlinearray[i+1];
					System.Gadget.Settings.writeString("numofaktmods",textlinearray[i+1]);
				}
				else if (textlinearray[i] == "modpositions")
				{
					modpositions.length = 0;
					modpositions = textlinearray[i+1];
					System.Gadget.Settings.writeString("modpositions",textlinearray[i+1]);
				}
				else
				{
					System.Gadget.Settings.writeString(textlinearray[i], textlinearray[i+1]);
				}
			}
			alert(SettText[60]);
			saverestoresettinfo.innerText = SettText[60];
//			LoadSettings();
//			event.cancel = false;
//			onUnload();
		}
		else { alert("No file was selected"); }
	}
}

function changefont()
{
	var nfz = 14;
	var i;
	for (i=0; i<mniFontsSuperBig.length;i++)
	{
		if(fontselect.value == mniFontsSuperBig[i])
		{
			nfz = nfz-4;
		}
	}
	for (i=0; i<mniFontsBig.length;i++)
	{
		if(fontselect.value == mniFontsBig[i])
		{
			nfz = nfz-2;
		}
	}
	for (i=0; i<mniFontsMiddle.length;i++)
	{
		if(fontselect.value == mniFontsMiddle[i])
		{
			nfz = nfz-1;
		}
	}
	for (i=0; i<mniFontsSmall.length;i++)
	{
		if(fontselect.value == mniFontsSmall[i])
		{
			nfz = nfz+1;
		}
	}

	prev_text_div.style.fontFamily = mniFonts[fontselect.value];
	prev_text_div.style.fontSize = nfz + "px";
}

function fillKWshowcombo()
{
	kwshowselect.options[0] = new Option(SettText[5], "0");
	kwshowselect.options[1] = new Option(SettText[37], "1");
	kwshowselect.options[2] = new Option(SettText[38], "2");
}

function fillKWcombo()
{
	kwselect.options[0] = new Option(SettText[34], "0"); // ISO
	kwselect.options[1] = new Option(SettText[35], "1"); // USA
	kwselect.options[2] = new Option(SettText[39], "2"); // JUL
	kwselect.options[3] = new Option(SettText[40], "3"); // ISL
}

function fillfirstwdaycombo()
{
	firstwdayselect.options[0] = new Option(clkDayslong[0], "0");
	firstwdayselect.options[1] = new Option(clkDayslong[1], "1");
}

function fillTZcombo()
{
	if (System.Gadget.Settings.read("timeZoneIndex") != "")
	{
		timeZoneIndex = System.Gadget.Settings.read("timeZoneIndex");
	}

	collTZones(true);

	currTZselect.options[0] = new Option(SettText[27], "-1");

	for (var i = 0; i < e.length; i++)
	{
		currTZselect.options[i+1] = new Option(e[i][eZone], e[i][eItem]);
		currTZselect.options[i+1].title = e[i][eZone];
	}

	currTZselect2.options[0] = new Option(SettText[27], "-1");

	for (var i = 0; i < e.length; i++)
	{
		currTZselect2.options[i+1] = new Option(e[i][eZone], e[i][eItem]);
		currTZselect2.options[i+1].title = e[i][eZone];
	}
}

function toggleHDDsettings()
{
	var mainset = document.getElementById('mainSettings');
	var hddset = document.getElementById('hddSettings');

	if(hddSettings.style.display=="none")
	{
		$(document).ready(function(){
			$(mainset).hide("normal");
			$(hddset).show("normal");
		});
	}
	else
	{
		$(document).ready(function(){
			$(hddset).hide("normal");
			$(mainset).show("normal");
		});
	}


}

function toggleClockCalendar()
{
	var clkset = document.getElementById('clocksettings');
	var calset = document.getElementById('calsettings');

	if(calsettings.style.display=="none")
	{
		$(document).ready(function(){
			$(clkset).hide("normal");
			$(calset).show("normal");
		});
	}
	else
	{
		$(document).ready(function(){
			$(calset).hide("normal");
			$(clkset).show("normal");
		});
	}


}

function toggledivColorPicker()
{
	var mset = document.getElementById('modsettings');
	var cset = document.getElementById('divCP');

	if(divCP.style.display=="none")
	{
		$(document).ready(function(){
			$(mset).hide("normal");
			$(cset).show("normal");
		});

		themetext.value = SettText[19];
	}
	else
	{
		$(document).ready(function(){
			$(cset).hide("normal");
			$(mset).show("normal");
		});

		themetext.value = SettText[16];
	}


}

function changeprvcolor(targetcolor,sourcecolor)
{
	if (targetcolor == "prev_text_div")
	{
		if (sourcecolor.value)
		{
			document.getElementById(targetcolor).style.backgroundColor = sourcecolor.value;
		}
		else
		{
			document.getElementById(targetcolor).style.backgroundColor = sourcecolor;
		}
	}
	else
	{
		if (sourcecolor.value)
		{
			document.getElementById(targetcolor).style.color = sourcecolor.value;
		}
		else
		{
			document.getElementById(targetcolor).style.color = sourcecolor;
		}
	}
}

function themeundo()
{
	divCP.style.display = "block";
	modsettings.style.display = "none";
	themetext.value = SettText[19];
	document.getElementsByName("themeinbck")[0].value = gadgetcolourback;
	document.getElementsByName("themeintxt1")[0].value = gadgetcolourlabel;
	document.getElementsByName("themeintxt2")[0].value = gadgetcolournormal;
	document.getElementsByName("themeintxt3")[0].value = gadgetcolourwarn;
	document.getElementsByName("themeintxt4")[0].value = gadgetcolourcritical;
	prev_text_div.style.backgroundColor = gadgetcolourback;
	prev_text_label.style.color = gadgetcolourlabel;
	prev_text_normal.style.color = gadgetcolournormal;
	prev_text_warn.style.color = gadgetcolourwarn;
	prev_text_critical.style.color = gadgetcolourcritical;

	buildthememods();
}

function themedefault()
{
	document.getElementsByName("themeinbck")[0].value = "black";
	document.getElementsByName("themeintxt1")[0].value = "white";
	document.getElementsByName("themeintxt2")[0].value = "turquoise";
	document.getElementsByName("themeintxt3")[0].value = "yellow";
	document.getElementsByName("themeintxt4")[0].value = "red";
	prev_text_div.style.backgroundColor = "black";
	prev_text_label.style.color = "white";
	prev_text_normal.style.color = "turquoise";
	prev_text_warn.style.color = "yellow";
	prev_text_critical.style.color = "red";

	buildthememods();
}

function nav(id)
{
	var sett1 = document.getElementById('divSettings');
	var sett2 = document.getElementById('divSettings2');
	var sett3 = document.getElementById('divLayout');
	var sett4 = document.getElementById('divUpdate');
	var sett5 = document.getElementById('divInformation');

	switch (id)
	{
		case 0:
			settbtn0.src = "/img/Settings/settBtnSettings_a.png";
			settbtn1.src = "/img/Settings/settBtnSettings2.png";
			settbtn2.src = "/img/Settings/settBtnLayout.png";
			settbtn3.src = "/img/Settings/settBtnUpdate.png";
			settbtn4.src = "/img/Settings/settBtnInfo.png";
			$(document).ready(function(){
			$(sett1).slideDown("normal");
			$(sett2).slideUp("normal");
			$(sett3).slideUp("normal");
			$(sett4).slideUp("normal");
			$(sett5).slideUp("normal");
			});
			break;
		case 1:
			settbtn0.src = "/img/Settings/settBtnSettings.png";
			settbtn1.src = "/img/Settings/settBtnSettings2_a.png";
			settbtn2.src = "/img/Settings/settBtnLayout.png";
			settbtn3.src = "/img/Settings/settBtnUpdate.png";
			settbtn4.src = "/img/Settings/settBtnInfo.png";
			$(document).ready(function(){
			$(sett1).slideUp("normal");
			$(sett2).slideDown("normal");
			$(sett3).slideUp("normal");
			$(sett4).slideUp("normal");
			$(sett5).slideUp("normal");
			});
			break;
		case 2:
			settbtn0.src = "/img/Settings/settBtnSettings.png";
			settbtn1.src = "/img/Settings/settBtnSettings2.png";
			settbtn2.src = "/img/Settings/settBtnLayout_a.png";
			settbtn3.src = "/img/Settings/settBtnUpdate.png";
			settbtn4.src = "/img/Settings/settBtnInfo.png";
			$(document).ready(function(){
			$(sett1).slideUp("normal");
			$(sett2).slideUp("normal");
			$(sett3).slideDown("normal");
			$(sett4).slideUp("normal");
			$(sett5).slideUp("normal");
			});
			break;
		case 3:
			settbtn0.src = "/img/Settings/settBtnSettings.png";
			settbtn1.src = "/img/Settings/settBtnSettings2.png";
			settbtn2.src = "/img/Settings/settBtnLayout.png";
			settbtn3.src = "/img/Settings/settBtnUpdate_a.png";
			settbtn4.src = "/img/Settings/settBtnInfo.png";
			$(document).ready(function(){
			$(sett1).slideUp("normal");
			$(sett2).slideUp("normal");
			$(sett3).slideUp("normal");
			$(sett4).slideDown("normal");
			$(sett5).slideUp("normal");
			});
			break;
		case 4:
			settbtn0.src = "/img/Settings/settBtnSettings.png";
			settbtn1.src = "/img/Settings/settBtnSettings2.png";
			settbtn2.src = "/img/Settings/settBtnLayout.png";
			settbtn3.src = "/img/Settings/settBtnUpdate.png";
			settbtn4.src = "/img/Settings/settBtnInfo_a.png";
			$(document).ready(function(){
			$(sett1).slideUp("normal");
			$(sett2).slideUp("normal");
			$(sett3).slideUp("normal");
			$(sett4).slideUp("normal");
			$(sett5).slideDown("normal");
			});
			initializemarquee();
			break;
	}
}

function fillCoresCombo()
{
	var i;
	if (numofcores > 1)
	{
		for (i = 2;i <= numofcores; i++)
		{
			numofcoresselect.options[numofcoresselect.length] = new Option(i, i);
		}
	}
	else
	{
		numofcoresselect.options[1] = new Option(1, SettText[5]);
	}
}

function fillInterfaceCombo()
{
	var i;
	for (i = 0;i < interfaceCount; i++)
	{
		wintfselect.options[wintfselect.length] = new Option(InterfaceArray[i], i);
		intfselect.options[intfselect.length] = new Option(InterfaceArray[i], i);
	}
}

function fillNetUsageCombo()
{
	netusageselect.options[0] = new Option(SettText[49], 0);
	netusageselect.options[1] = new Option(SettText[50], 1);
	netusageselect.options[2] = new Option(SettText[51], 2);
}

function fillFontCombo()
{
	var i;
	for (i = 0;i < mniFonts.length; i++)
	{
		fontselect.options[fontselect.length] = new Option(mniFonts[i], i);
	}
}

function fillDFCombo()
{
	var Vortag  = ((Tag < 10) ? "0" : "");
	var Vormon  = ((Monat < 10) ? "0" : "");
	var Vorstd  = ((Stunden < 10) ? "0" : "");
	var Vormin  = ((Minuten < 10) ? "0" : "");
	var Vorsek  = ((Sekunden < 10) ? "0" : "");

	for (var i = 1;i < dateformatArray.length; i++)
	{
		var DFstring = "";
		var cDF = "";
		cDF = dateformatArray[i].split("");
		for (var x=0; x<cDF.length; x++)
		{
			if (cDF[x] === "W")
			{
				DFstring += clkDays[WoTag];
			}
			else if (cDF[x] === "w")
			{
				DFstring += clkDayslong[WoTag];
			}
			else if (cDF[x] === "D")
			{
				DFstring += Vortag + Tag;
			}
			else if (cDF[x] === "d")
			{
				DFstring += Tag;
			}
			else if (cDF[x] === "M")
			{
				DFstring += clkMonth[Monat];
			}
			else if (cDF[x] === "m")
			{
				DFstring += Monat;
			}
			else if (cDF[x] === "L")
			{
				DFstring += clkMonthlong[Monat];
			}
			else if (cDF[x] === "l")
			{
				DFstring += Vormon + Monat;
			}
			else if (cDF[x] === "Y")
			{
				DFstring += Jahr;
			}
			else if (cDF[x] === ".")
			{
				DFstring += ".";
			}
			else if (cDF[x] === " ")
			{
				DFstring += " ";
			}
			else if (cDF[x] === "/")
			{
				DFstring += "/";
			}
			else if (cDF[x] === "-")
			{
				DFstring += "-";
			}
			else if (cDF[x] === ",")
			{
				DFstring += ",";
			}
			else
			{
				DFstring += "";
			}
		}
		currentDFselect.options[currentDFselect.length] = new Option(DFstring, i);
	}
}

function onchangeaction(wert)
{
	if (wert == "cpumodbox")
	{
		if (cpumodbox.checked!=false)
		{
			cpubox.disabled=false;
			checktext.style.color=gadgetcolourlabel;
		}
		else
		{
			cpubox.disabled=true;
			checktext.style.color="gray";
		}
	}
	if (wert == "uptmodbox")
	{
		if (uptmodbox.checked!=false)
		{
			uptsecondsbox.disabled=false;
			uptsecondstext.style.color=gadgetcolourlabel;
		}
		else
		{
			uptsecondsbox.disabled=true;
			uptsecondstext.style.color="gray";
		}
	}
	if (wert == "hddmodbox")
	{
		if (hddmodbox.checked!=false)
		{
			hddboxes1.style.display="block";
			hddboxes1.style.color=gadgetcolourlabel;
			hddForm.style.color=gadgetcolourlabel;
			hddtext.style.color=gadgetcolourlabel;
		}
		else
		{
			hddboxes1.style.display="none";
			hddboxes1.style.color="gray";
			hddForm.style.color="gray";
			hddtext.style.color="gray";
		}
		onchangeaction("dualcoreusebox");
	}
	if (wert == "rammodbox")
	{
		if (rammodbox.checked!=false)
		{
			dualcoreusebox.disabled=false;
			dualcoreusetext.style.color=gadgetcolourlabel;
			numofcoresselect.disabled=false;
		}
		else
		{
			dualcoreusebox.disabled=true;
			dualcoreusetext.style.color="gray";
			numofcoresselect.disabled=true;
		}
		onchangeaction("dualcoreusebox");
	}
	if (wert == "dualcoreusebox")
	{
		if (dualcoreusebox.checked!=false)
		{
			numofcoresselect.disabled=true;
//			numofcoresselect.disabled=false;
		}
		else
		{
			numofcoresselect.disabled=true;
		}
	}
	if (wert == "batmodbox")
	{
		if (batmodbox.checked!=false)
		{
			bcalcbox.disabled=false;
			bcaltext.style.color=gadgetcolourlabel;
			batbeepbox.disabled=false;
			batbeeptext.style.color=gadgetcolourlabel;
		}
		else
		{
			bcalcbox.disabled=true;
			bcaltext.style.color="gray";
			batbeepbox.disabled=true;
			batbeeptext.style.color="gray";
		}
	}
	if (wert == "netmodbox")
	{
		if (netmodbox.checked!=false)
		{
			wifistylebox.disabled=false;
			wifistyletext.style.color=gadgetcolourlabel;
			netusagebox.disabled=false;
			netusagetext.style.color=gadgetcolourlabel;
			if (netusagebox.checked!=false)
			{
				netusageselect.disabled=false;
			}
			else
			{
				netusageselect.disabled=true;
			}
		}
		else
		{
			wifistylebox.disabled=true;
			wifistyletext.style.color="gray";
			netusagebox.disabled=true;
			netusagetext.style.color="gray";
			if (netusagebox.checked!=false)
			{
				netusageselect.disabled=false;
			}
			else
			{
				netusageselect.disabled=true;
			}
		}
	}

	if (wert == "netusagebox")
	{
		if (netusagebox.checked!=false)
		{
			netusageselect.disabled=false;
		}
		else
		{
			netusageselect.disabled=true;
		}
	}

	if (wert == "animatebox")
	{
		var cset = document.getElementById('clocknametext');
		var mset = document.getElementById('clocknameinput');
		if (animatebox.checked==false)
		{
			$(document).ready(function(){
			$(cset).slideDown("normal");
			$(mset).slideDown("normal");
			});
			clocknameinput.disabled=false;
			clocknametext.style.color=gadgetcolourlabel;
			clockdnametext.style.marginTop = -37;
		}
		else
		{
			$(document).ready(function(){
			$(cset).slideUp("normal");
			$(mset).slideUp("normal");
			});
			clocknameinput.disabled=true;
			clocknametext.style.color="gray";
			clockdnametext.style.marginTop = 0;
		}
	}
	if (wert == "clk2onoffbox")
	{
		var cset = document.getElementById('clk2content');
		if (clk2onoffbox.checked==true)
		{
			$(document).ready(function(){
			$(cset).slideDown("normal");
			});
		}
		else
		{
			$(document).ready(function(){
			$(cset).slideUp("normal");
			});
		}
	}
	if (wert == "currentDF")
	{
		var cset = document.getElementById('clockdnametext');
		var mset = document.getElementById('clockdnameinput');
		if (currentDFselect.value==0)
		{
			$(document).ready(function(){
			$(cset).slideDown("normal");
			$(mset).slideDown("normal");
			});
			clockdnameinput.disabled=false;
			clockdnametext.style.color=gadgetcolourlabel;
		}
		else
		{
			$(document).ready(function(){
			$(cset).slideUp("normal");
			$(mset).slideUp("normal");
			});
			clockdnameinput.disabled=true;
			clockdnametext.style.color="gray";
		}
	}

	if (wert == "firstwdayselect")
	{
		if (firstwdayselect.value == 0) // sunday
		{
			if (kwselect.value == 0)
			{
				alert(SomeText[2]);
				firstwdayselect.value = 1;
			}
		}
		else if (firstwdayselect.value == 1) // monday
		{
			if (kwselect.value == 0)
			{
			}
		}
	}

	if (wert == "kwselect")
	{
		if (kwselect.value == 0) // ISO
		{
			firstwdayselect.value = 1;
			kwshowselect.disabled=false;
			kwshowtext.style.color=gadgetcolourlabel;
			firstwdayselect.disabled=true;
			firstwdayselect.style.color="gray";
		}
		else if (kwselect.value == 1) // USA
		{
			kwshowselect.disabled=false;
			kwshowtext.style.color=gadgetcolourlabel;
			firstwdayselect.disabled=false;
			firstwdayselect.style.color=gadgetcolourlabel;
		}
		else if (kwselect.value == 2) // Julian
		{
			kwshowselect.disabled=true;
			kwshowtext.style.color="gray";
			firstwdayselect.disabled=false;
			firstwdayselect.style.color=gadgetcolourlabel;
		}
		else if (kwselect.value == 3) // Islamic
		{
			firstwdayselect.value = 0;
			firstwdayselect.disabled=true;
			firstwdayselect.style.color="gray";
			kwshowselect.disabled=true;
			kwshowtext.style.color="gray";
		}
		else
		{
			firstwdayselect.value = 1;
			kwshowselect.disabled=false;
			kwshowtext.style.color=gadgetcolourlabel;
			firstwdayselect.disabled=true;
			firstwdayselect.style.color="gray";
		}
	}
 	if (wert == "clkmodbox")
	{
		var cset = document.getElementById('clk2content');
		if (clkmodbox.checked!=false)
		{
			ampmbox.disabled=false;
			ampmtext.style.color=gadgetcolourlabel;
			animatebox.disabled=false;
			animatetext.style.color=gadgetcolourlabel;
			if (animatebox.checked==false)
			{
				clocknameinput.disabled=false;
				clocknametext.style.color=gadgetcolourlabel;
			}
			else
			{
				clocknameinput.disabled=true;
				clocknametext.style.color="gray";
			}
			currentDFselect.disabled=false;
			currentDFtext.style.color=gadgetcolourlabel;
			currTZselect.disabled=false;
			currTZtext.style.color=gadgetcolourlabel;

			if (clk2onoffbox.checked==true)
			{
				clk2content.style.display="block";
				$(document).ready(function(){
				$(cset).slideDown("normal");
				});
			}
			clk2onoffbox.disabled=false;
			clk2onofftext.style.color=gadgetcolourlabel;
		}
		else
		{
			ampmbox.disabled=true;
			ampmtext.style.color="gray";
			animatebox.disabled=true;
			animatetext.style.color="gray";
			clocknameinput.disabled=true;
			clocknametext.style.color="gray";
			currentDFselect.disabled=true;
			currentDFtext.style.color="gray";
			currTZselect.disabled=true;
			currTZtext.style.color="gray";

			if (clk2onoffbox.checked==true)
			{
				clk2content.style.display="none";
				$(document).ready(function(){
				$(cset).slideUp("normal");
				});
			}
			clk2onoffbox.disabled=true;
			clk2onofftext.style.color="gray";
		}
	}
 	if (wert == "calmodbox")
	{
		if (calmodbox.checked!=false)
		{
			kwselect.disabled=false;
			kwtext.style.color=gadgetcolourlabel;
			firstwdayselect.disabled=false;
			firstwdaytext.style.color=gadgetcolourlabel;
			kwshowselect.disabled=false;
			kwshowtext.style.color=gadgetcolourlabel;
		}
		else
		{
			kwselect.disabled=true;
			kwtext.style.color="gray";
			firstwdayselect.disabled=true;
			firstwdaytext.style.color="gray";
			kwshowselect.disabled=true;
			kwshowtext.style.color="gray";
		}
		onchangeaction("kwselect");
	}
	if (wert == "transbackbox")
	{
		var bset = document.getElementById('divback');
		if (transbackbox.checked!=true)
		{
			$(document).ready(function(){
			$(bset).slideDown("normal");
			});
			divlabel.style.marginTop = "-15px";
			themeinback.disabled=false;
			themebuttonback.disabled=false;
		}
		else
		{
			$(document).ready(function(){
			$(bset).slideUp("normal");
			});
			divlabel.style.marginTop = "0px";
			themeinback.disabled=true;
			themebuttonback.disabled=true;
		}
	}
	if (wert == "wifistylebox")
	{
		if (wifistylebox.checked!=false)
		{
			classicWiFi = 1;
		}
		else
		{
			classicWiFi = 0;
		}
		inittheme();
	}
}

function IEpreventOnChangeBug()
{
}

function change_prvw_mods(name)
{
	var tempid, tempname, newmodpositionsstring, newid, newname, newnumofaktmods;
	tempid = name + "modbox";

	if (document.getElementById(tempid).checked != false)
	{
		modpositionsstring += ",";
		modpositionsstring += numofaktmods + ",";
		modpositionsstring += name + ",";
		modpositionsstring += "p" + numofaktmods;

		modpositions[numofaktmods] = new Object();
		modpositions[numofaktmods][name] = "p" + numofaktmods;

		numofaktmods++;

		rebuildpositionstring(modpositionsstring);
		buildthememods();
	}
	else
	{
		newnumofaktmods = numofaktmods-1;
		if (newnumofaktmods < 1)
		{
			alert(SettText[11]);
			document.getElementById(tempid).checked = true;
			return;
		}

		newmodpositionsstring = "";
		modpositions = "";
		modpositions = new Array();
		var i2=0;
		for (var i = 0; i < modpositionsstring.length; i=i+3)
		{
			if (name != modpositionsstring[i+1])
			{
				newmodpositionsstring += i2 + ",";
				newmodpositionsstring += modpositionsstring[i+1] + ",";
				newmodpositionsstring += "p" + i2;
				if (i2 < (newnumofaktmods-1))
				{
					newmodpositionsstring += ",";
				}

				modpositions[i2] = new Object();
				modpositions[i2][modpositionsstring[i+1]] = "p" + i2;
				i2++;
			}
		}

		rebuildpositionstring(newmodpositionsstring);
		buildthememods();
	}
}

function sortmods(direction, id)
{
	var tempid, tempname, newtempid, newtempname, splitid, newmodpositionsstring, tid;
	newmodpositionsstring = "";
	splitid = id.split("");
	splitid[1] = parseInt(splitid[1]);

	if (direction == "up")
	{
		for (var i=0; i<numofaktmods; i++)
		{
			if (i == (splitid[1]-1))
			{
				tempid = "p" + i;
				newtempid = "p" + (i+1);
				tempname = document.getElementById(newtempid).name;
				newtempname = document.getElementById(tempid).name;
				newmodpositionsstring += i + ",";
				newmodpositionsstring += tempname + ",";
				newmodpositionsstring += tempid;
			}
			else if (i == splitid[1])
			{
				newmodpositionsstring += i + ",";
				newmodpositionsstring += newtempname + ",";
				newmodpositionsstring += newtempid;
			}
			else if (i > splitid[1])
			{
				tid = "p" + i;
				newmodpositionsstring += i + ",";
				newmodpositionsstring += document.getElementById(tid).name + ",";
				newmodpositionsstring += tid;
			}
			else if (i < splitid[1])
			{
				tid = "p" + i;
				newmodpositionsstring += i + ",";
				newmodpositionsstring += document.getElementById(tid).name + ",";
				newmodpositionsstring += tid;
			}

			if (i < (numofaktmods-1))
			{
				newmodpositionsstring += ",";
			}
			tempid = "";
			tempname = "";
			tid = "";
		}
		newtempid = "";
		newtempname = "";
	}
	else if (direction == "down")
	{
		for (var i=0; i<numofaktmods; i++)
		{
			if (i == splitid[1])
			{
				tempid = "p" + i;
				newtempid = "p" + (i+1);
				tempname = document.getElementById(newtempid).name;
				newtempname = document.getElementById(tempid).name;
				newmodpositionsstring += i + ",";
				newmodpositionsstring += tempname + ",";
				newmodpositionsstring += tempid;
			}
			else if (i == (splitid[1]+1))
			{
				newmodpositionsstring += i + ",";
				newmodpositionsstring += newtempname + ",";
				newmodpositionsstring += newtempid;
			}
			else if (i > splitid[1])
			{
				tid = "p" + i;
				newmodpositionsstring += i + ",";
				newmodpositionsstring += document.getElementById(tid).name + ",";
				newmodpositionsstring += tid;
			}
			else if (i < splitid[1])
			{
				tid = "p" + i;
				newmodpositionsstring += i + ",";
				newmodpositionsstring += document.getElementById(tid).name + ",";
				newmodpositionsstring += tid;
			}

			if (i < (numofaktmods-1))
			{
				newmodpositionsstring += ",";
			}
			tempid = "";
			tempname = "";
			tid = "";
		}
		newtempid = "";
		newtempname = "";
	}

	rebuildpositionstring(newmodpositionsstring);
	buildthememods();
}

function inittheme()
{
	modpositionsstring = "";
	modpositionsstring = System.Gadget.Settings.read("modpositions").split(",");
	var i2=0;
	for (var i = 0; i < modpositionsstring.length; i=i+3)
	{
		modpositions[i2] = new Object();
		modpositions[i2][modpositionsstring[i+1]] = modpositionsstring[i+2];
		i2++;
	}
	numofaktmods = modpositions.length;
	buildthememods();
}

function rebuildpositionstring(newmodpositionsstring)
{
	modpositionsstring = "";
	modpositionsstring = newmodpositionsstring.split(",");
	modpositions = "";
	modpositions = new Array();
	var i2=0;
	for (var i = 0; i < modpositionsstring.length; i=i+3)
	{
		modpositions[i2] = new Object();
		modpositions[i2][modpositionsstring[i+1]] = modpositionsstring[i+2];
		i2++;
	}
	numofaktmods = modpositions.length;
}

function buildthememods()
{
	modseq.innerHTML = "";

	var tempsrc, tempsrcu, tempsrcd, tempsrcui, tempsrcdi;
	var tempid, tempname, temptable, prvpath, prvcolor;

	if(document.getElementsByName("themeinbck")[0].value)
	{
		prvcolor = document.getElementsByName("themeinbck")[0].value;
	}
	else if (gadgetcolourback)
	{
		prvcolor = gadgetcolourback;
	}
	else
	{
		prvcolor = "black";
	}
	document.getElementsByName("themeinbck")[0].value = prvcolor;

	prvpath = "/img/Settings/preview/";
	tempsrcu = prvpath + "prvw_up_akt.png";
	tempsrcd = prvpath + "prvw_down_akt.png";
	tempsrcui = prvpath + "prvw_up_inakt.png";
	tempsrcdi = prvpath + "prvw_down_inakt.png";

	temptable = "<table cellpadding=\"0\" cellspacing=\"2\" border=\"0\">";
	temptable += "<tr><td valign=\"bottom\" bgcolor=\"" + prvcolor + "\"><img width=\"109\" id=\"prvwhead\" src=\"" + prvpath + "/preview_head.png\"></td>";
	temptable += "<td></td>";
	temptable += "</tr>";
	temptable += "";
	for (var i2=0; i2<numofaktmods; i2++)
	{
		tempid = "p" + i2;
		for (var i = 0; i < numofaktmods; i++)
		{
			for (var pos in modpositions[i])
			{
				if (modpositions[i][pos] == tempid)
				{
					tempname = pos;
					if ((classicWiFi == 1) && (tempname == "net"))
					{
						tempsrc = prvpath + "/preview_" + tempname + "_classic.png";
					}
					else
					{
						tempsrc = prvpath + "/preview_" + tempname + ".png";
					}

					temptable += "<tr><td rowspan=\"2\" bgcolor=\"" + prvcolor + "\"><img width=\"109\" id=\"" + tempid + "\" name=\"" + tempname + "\" src=\"" + tempsrc + "\"></td>";
					if (i2 == 0)
					{
						temptable += "<td valign=\"bottom\" width=\"20\"><img id=\"" + tempid + "u\" src=\"" + tempsrcui + "\"></td>";
					}
					else
					{
						temptable += "<td valign=\"bottom\" width=\"20\"><img id=\"" + tempid + "u\" src=\"" + tempsrcu + "\" onclick=\"sortmods('up', '" + tempid + "')\" style=\"cursor:pointer;\"></td>";
					}
					temptable += "</tr>";
					if (i2 == (numofaktmods-1))
					{
						temptable += "<tr><td valign=\"top\" width=\"20\"><img id=\"" + tempid + "d\" src=\"" + tempsrcdi + "\"></td>";
					}
					else
					{
						temptable += "<tr><td valign=\"top\" width=\"20\"><img id=\"" + tempid + "d\" src=\"" + tempsrcd + "\" onclick=\"sortmods('down', '" + tempid + "')\" style=\"cursor:pointer;\"></td>";
					}
					temptable += "</tr>";
				}
			}
		}
	}
	temptable += "<tr><td valign=\"top\" bgcolor=\"" + prvcolor + "\"><img width=\"109\" id=\"prvwfoot\" src=\"" + prvpath + "/preview_foot.png\"></td>";
	temptable += "<td></td>";
	temptable += "</tr>";
	temptable += "</table>";
	modseq.innerHTML = temptable;
}

function SettingsClosing(event, settsave)
{
	var tmpsettfile = "";

	// Save the settings if the user clicked OK or if it should be written to a file.
	if ((settsave) || (event.closeAction == event.Action.commit))
	{
		if (!calmodbox.checked && !clkmodbox.checked && !uptmodbox.checked && !cpumodbox.checked && !hddmodbox.checked && !rammodbox.checked && !netmodbox.checked && !batmodbox.checked && !pwrmodbox.checked)
		{
			alert(SettText[11]);
			return;
		}
		else
		{
			gadgetheightsum = gadgetheightcontainer;
			if (clkmodbox.checked!=false)
			{
				if (clk2onoffbox.checked!=false)
				{
					gadgetheightsum += clkmodheight;
					gadgetheightsum += clk2modheight;
				}
				else
				{
					gadgetheightsum += clkmodheight;
				}
			}
			if (calmodbox.checked!=false)
			{
				gadgetheightsum += calmodheight;
			}
			if (uptmodbox.checked!=false)
			{
				gadgetheightsum += uptmodheight;
			}
			if (cpumodbox.checked!=false)
			{
				gadgetheightsum += cpumodheight;
			}
			if (netmodbox.checked!=false)
			{
				gadgetheightsum += netmodheight;
			}
			if (batmodbox.checked!=false)
			{
				gadgetheightsum += batmodheight;
			}
			if (pwrmodbox.checked!=false)
			{
				gadgetheightsum += pwrmodheight;
			}
			if (hddmodbox.checked!=false)
			{
				var tmphddcnt=0;
				var ssid = System.Gadget.document.parentWindow.wireless.ssid;
				var lstat = System.Gadget.document.parentWindow.lstat;

				if ((ssid != "") || (lstat))
				{
					for (var i in hddletters_arr)
					{
						if (System.Shell.drive(hddletters_arr[i])) {
							if (System.Shell.drive(hddletters_arr[i]).isReady) {
								if (hddboxes_arr[i] == "false")
								{
									tmphddcnt++;
								}
							}
						}
					}
				}
				else
				{
					for (var i in hddletters_arr)
					{
						if (System.Shell.drive(hddletters_arr[i])) {
							if ((System.Shell.drive(hddletters_arr[i]).driveType != 4) &&
								(System.Shell.drive(hddletters_arr[i]).driveType != 5))
//							if (System.Shell.drive(hddletters_arr[i]).driveType != 4)
							{
								if (System.Shell.drive(hddletters_arr[i]).isReady) {
									if (hddboxes_arr[i] == "false")
									{
										tmphddcnt++;
									}
								}
							}
						}
					}
				}

				hddmodheightsum = singlehddusageheight * tmphddcnt;
				gadgetheightsum += hddmodheightsum;
				if (settsave == "1") {
					tmpsettfile += "hddmodheightsum" + "||" + hddmodheightsum + "||";
				}
				else {
					System.Gadget.Settings.write("hddmodheightsum", hddmodheightsum);
				}
			}
			if (rammodbox.checked!=false)
			{
				if (dualcoreusebox.checked!=false)
				{
					rammodheightsum = singleusageheight * (parseInt(numofcoresselect.value) + 1) +3;
				}
				else
				{
					rammodheightsum = singleusageheight * 2 +3;
				}
				gadgetheightsum += rammodheightsum;
				if (settsave == "1") {
					tmpsettfile += "rammodheightsum" + "||" + rammodheightsum + "||";
				}
				else {
					System.Gadget.Settings.write("rammodheightsum", rammodheightsum);
				}
			}

			if (settsave == "1") {
				tmpsettfile += "gadgetheightsum" + "||" + gadgetheightsum + "||";
			}
			else {
				System.Gadget.Settings.write("gadgetheightsum", gadgetheightsum);
			}

			if (clk2onoffbox.checked!=false)
			{
				if (settsave == "1") {
					tmpsettfile += "clkmodheightsum" + "||" + (clkmodheight+clk2modheight) + "||";
				}
				else {
					System.Gadget.Settings.write("clkmodheightsum",clkmodheight+clk2modheight);
				}
			}
			else
			{
				if (settsave == "1") {
					tmpsettfile += "clkmodheightsum" + "||" + clkmodheight + "||";
				}
				else {
					System.Gadget.Settings.write("clkmodheightsum",clkmodheight);
				}
			}

			if (settsave == "1") {
				tmpsettfile += "rammodheight" + "||" + rammodheight + "||";

				tmpsettfile += "clkmodbox" + "||" + clkmodbox.checked + "||";
				tmpsettfile += "clk2onoffbox" + "||" + clk2onoffbox.checked + "||";
				tmpsettfile += "calmodbox" + "||" + calmodbox.checked + "||";
				tmpsettfile += "uptmodbox" + "||" + uptmodbox.checked + "||";
				tmpsettfile += "cpumodbox" + "||" + cpumodbox.checked + "||";
				tmpsettfile += "netmodbox" + "||" + netmodbox.checked + "||";
				tmpsettfile += "batmodbox" + "||" + batmodbox.checked + "||";
				tmpsettfile += "hddmodbox" + "||" + hddmodbox.checked + "||";
				tmpsettfile += "rammodbox" + "||" + rammodbox.checked + "||";
				tmpsettfile += "pwrmodbox" + "||" + pwrmodbox.checked + "||";
			}
			else {
				System.Gadget.Settings.write("rammodheight", rammodheight);

				System.Gadget.Settings.write("clkmodbox", clkmodbox.checked);
				System.Gadget.Settings.write("clk2onoffbox", clk2onoffbox.checked);
				System.Gadget.Settings.write("calmodbox", calmodbox.checked);
				System.Gadget.Settings.write("uptmodbox", uptmodbox.checked);
				System.Gadget.Settings.write("cpumodbox", cpumodbox.checked);
				System.Gadget.Settings.write("netmodbox", netmodbox.checked);
				System.Gadget.Settings.write("batmodbox", batmodbox.checked);
				System.Gadget.Settings.write("hddmodbox", hddmodbox.checked);
				System.Gadget.Settings.write("rammodbox", rammodbox.checked);
				System.Gadget.Settings.write("pwrmodbox", pwrmodbox.checked);
			}

			if (cpuclockbox1.checked!=false)
			{
				if (settsave == "1") {
					tmpsettfile += "dispdualcpu" + "||" + "True" + "||";
				}
				else {
					System.Gadget.Settings.write("dispdualcpu", "True");
				}
			}
			else
			{
				if (settsave == "1") {
					tmpsettfile += "dispdualcpu" + "||" + "False" + "||";
				}
				else {
					System.Gadget.Settings.write("dispdualcpu", "False");
				}
			}
			if (cpuclockbox2.checked!=false)
			{
				if (settsave == "1") {
					tmpsettfile += "dispdualcore" + "||" + "True" + "||";
				}
				else {
					System.Gadget.Settings.write("dispdualcore", "True");
				}
			}
			else
			{
				if (settsave == "1") {
					tmpsettfile += "dispdualcore" + "||" + "False" + "||";
				}
				else {
					System.Gadget.Settings.write("dispdualcore", "False");
				}
			}
			if (settsave == "1") {
				tmpsettfile += "currentCores" + "||" + numofcoresselect.value + "||";
				tmpsettfile += "dispinghz" + "||" + cpubox.checked + "||";
				tmpsettfile += "autoupdate" + "||" + aupdatebox.checked + "||";
				tmpsettfile += "batbeepbox" + "||" + batbeepbox.checked + "||";
				tmpsettfile += "dualcoreusebox" + "||" + dualcoreusebox.checked + "||";
				tmpsettfile += "ampmbox" + "||" + ampmbox.checked + "||";
				tmpsettfile += "animatebox" + "||" + animatebox.checked + "||";
				tmpsettfile += "altbcal" + "||" + bcalcbox.checked + "||";
				tmpsettfile += "transbackbox" + "||" + transbackbox.checked + "||";
				tmpsettfile += "classicWiFi" + "||" + wifistylebox.checked + "||";
				tmpsettfile += "uptsecondsbox" + "||" + uptsecondsbox.checked + "||";
			}
			else {
				System.Gadget.Settings.write("currentCores", numofcoresselect.value);
				System.Gadget.Settings.write("dispinghz", cpubox.checked);
				System.Gadget.Settings.write("autoupdate", aupdatebox.checked);
				System.Gadget.Settings.write("batbeepbox", batbeepbox.checked);
				System.Gadget.Settings.write("dualcoreusebox", dualcoreusebox.checked);
				System.Gadget.Settings.write("ampmbox", ampmbox.checked);
				System.Gadget.Settings.write("animatebox", animatebox.checked);
				System.Gadget.Settings.write("altbcal", bcalcbox.checked);
				System.Gadget.Settings.write("transbackbox", transbackbox.checked);
				System.Gadget.Settings.write("classicWiFi", wifistylebox.checked);
				System.Gadget.Settings.write("uptsecondsbox", uptsecondsbox.checked);
			}

			for (var i in hddletters_arr)
			{
				var tmphddcheckbox="hdd" + hddletters_arr[i] + "box";
				hddcheckbox = document.getElementById(tmphddcheckbox)
				hddboxes_arr[i] = hddcheckbox.checked;
			}
			if (settsave == "1") {
				tmpsettfile += "hddboxes_arr" + "||" + hddboxes_arr + "||";

				tmpsettfile += "wintfselect" + "||" + wintfselect.value + "||";
				tmpsettfile += "wintfname" + "||" + InterfaceArray[wintfselect.value] + "||";

				tmpsettfile += "intfselect" + "||" + intfselect.value + "||";
				tmpsettfile += "intfname" + "||" + InterfaceArray[intfselect.value] + "||";

				tmpsettfile += "InterfaceArray" + "||" + InterfaceArray + "||";

				tmpsettfile += "netusagebox" + "||" + netusagebox.checked + "||";
				tmpsettfile += "currentNetusage" + "||" + netusageselect.value + "||";

				tmpsettfile += "fontselect" + "||" + fontselect.value + "||";

				tmpsettfile += "currentDF" + "||" + currentDFselect.value + "||";
				tmpsettfile += "timeZoneIndex" + "||" + currTZselect.value + "||";
				tmpsettfile += "clocknameinput" + "||" + clocknameinput.value + "||";
				tmpsettfile += "clockdnameinput" + "||" + clockdnameinput.value + "||";
				tmpsettfile += "timeZoneIndex2" + "||" + currTZselect2.value + "||";
				tmpsettfile += "clock2nameinput" + "||" + clock2nameinput.value + "||";
				tmpsettfile += "firstwdayselect" + "||" + firstwdayselect.value + "||";
				tmpsettfile += "kwselect" + "||" + kwselect.value + "||";
				tmpsettfile += "kwshowselect" + "||" + kwshowselect.value + "||";
			}
			else {
				System.Gadget.Settings.write("hddboxes_arr", hddboxes_arr);

				System.Gadget.Settings.write("wintfselect", wintfselect.value);
				System.Gadget.Settings.write("wintfname", InterfaceArray[wintfselect.value]);

				System.Gadget.Settings.write("intfselect", intfselect.value);
				System.Gadget.Settings.write("intfname", InterfaceArray[intfselect.value]);

				System.Gadget.Settings.write("InterfaceArray", InterfaceArray)

				System.Gadget.Settings.write("netusagebox", netusagebox.checked);
				System.Gadget.Settings.write("currentNetusage", netusageselect.value);

				System.Gadget.Settings.write("fontselect", fontselect.value);

				System.Gadget.Settings.write("currentDF",currentDFselect.value);
				System.Gadget.Settings.write("timeZoneIndex",currTZselect.value);
				System.Gadget.Settings.write("clocknameinput", clocknameinput.value);
				System.Gadget.Settings.write("clockdnameinput", clockdnameinput.value);
				System.Gadget.Settings.write("timeZoneIndex2",currTZselect2.value);
				System.Gadget.Settings.write("clock2nameinput", clock2nameinput.value);
				System.Gadget.Settings.write("firstwdayselect",firstwdayselect.value);
				System.Gadget.Settings.write("kwselect", kwselect.value);
				System.Gadget.Settings.write("kwshowselect", kwshowselect.value);
			}
			if (CalApppath.value == "")
			{
				if (settsave == "1") {
					tmpsettfile += "CalApppath" + "||" + "C:\\Program Files\\Windows Calendar\\WinCal.exe" + "||";
					tmpsettfile += "CalAppName" + "||" + "WinCal" + "||";
				}
				else {
					System.Gadget.Settings.write("CalApppath", "C:\\Program Files\\Windows Calendar\\WinCal.exe");
					System.Gadget.Settings.write("CalAppName", "WinCal");
				}
			}
			else
			{
				if (settsave == "1") {
					tmpsettfile += "CalApppath" + "||" + CalApppath.value + "||";
					tmpsettfile += "CalAppName" + "||" + CalAppName + "||";
				}
				else {
					System.Gadget.Settings.write("CalApppath", CalApppath.value);
					System.Gadget.Settings.write("CalAppName", CalAppName);
				}
			}
			if (settsave == "1") {
				tmpsettfile += "CalAppargs" + "||" + CalAppargs.value + "||";

				tmpsettfile += "gadgetcolourback" + "||" + document.getElementsByName("themeinbck")[0].value + "||";
				tmpsettfile += "gadgetcolourlabel" + "||" + document.getElementsByName("themeintxt1")[0].value + "||";
				tmpsettfile += "gadgetcolournormal" + "||" + document.getElementsByName("themeintxt2")[0].value + "||";
				tmpsettfile += "gadgetcolourwarn" + "||" + document.getElementsByName("themeintxt3")[0].value + "||";
				tmpsettfile += "gadgetcolourcritical" + "||" + document.getElementsByName("themeintxt4")[0].value + "||";

				tmpsettfile += "numofaktmods" + "||" + numofaktmods + "||";
				tmpsettfile += "modpositions" + "||" + modpositionsstring + "||";

				tmpsettfile += "settfirstrun" + "||" + "set";
			}
			else {
				System.Gadget.Settings.write("CalAppargs", CalAppargs.value);

				System.Gadget.Settings.write("gadgetcolourback", document.getElementsByName("themeinbck")[0].value);
				System.Gadget.Settings.write("gadgetcolourlabel", document.getElementsByName("themeintxt1")[0].value);
				System.Gadget.Settings.write("gadgetcolournormal", document.getElementsByName("themeintxt2")[0].value);
				System.Gadget.Settings.write("gadgetcolourwarn", document.getElementsByName("themeintxt3")[0].value);
				System.Gadget.Settings.write("gadgetcolourcritical", document.getElementsByName("themeintxt4")[0].value);

				System.Gadget.Settings.write("numofaktmods",numofaktmods);
				System.Gadget.Settings.write("modpositions",modpositionsstring);

				System.Gadget.Settings.write("settfirstrun","set");
			}
		}
	}

	if (settsave == "1")
	{
		var sPath = System.Shell.saveFileDialog('',"Text File:*.txt");
		if (sPath != "")
		{
			// Initialize the Stream object enums.
			// Sets or returns the type of data in a Stream object.
			// 2 = text data.
			var adTypeText = 2;
			// Sets whether a file should be created if it does not exist or overwritten if it does.
			// 2 = overwrites the file with the data from a Stream object.
			var adSaveCreateOverWrite = 2;
			// Sets or returns the available permissions for modifying data.
			// 3 = read/write.
			var adModeReadWrite = 3;

			var oStream = new ActiveXObject("ADODB.Stream");
			with(oStream)
			{
				Mode = adModeReadWrite;
				Type = adTypeText;
				Open();
				WriteText(tmpsettfile);
				SaveToFile(sPath,adSaveCreateOverWrite);
				Close();
			}
			saverestoresettinfo.innerText = SettText[59];
		}
		else { alert("No settings saved."); }
	}

	// Allow the Settings dialog to close.
	if (!settsave) { event.cancel = false; }
}

/***********************************************
* Cross browser Marquee II- © Dynamic Drive (www.dynamicdrive.com)
* This notice MUST stay intact for legal use
* Visit http://www.dynamicdrive.com/ for this script and 100s more.
***********************************************/

var delayb4scroll=1000 //Specify initial delay before marquee starts to scroll on page (2000=2 seconds)
var marqueespeed=1 //Specify marquee scroll speed (larger is faster 1-10)
var pauseit=1 //Pause marquee onMousever (0=no. 1=yes)?

////NO NEED TO EDIT BELOW THIS LINE////////////

var copyspeed=marqueespeed
var pausespeed=(pauseit==0)? copyspeed: 0
var actualheight=''

function scrollmarquee(){
if (parseInt(cross_marquee.style.top)>(actualheight*(-1)+8))
cross_marquee.style.top=parseInt(cross_marquee.style.top)-copyspeed+"px"
else
cross_marquee.style.top=parseInt(marqueeheight)+8+"px"
}

function initializemarquee(){
cross_marquee=document.getElementById("vmarquee")
cross_marquee.style.top=0
marqueeheight=document.getElementById("marqueecontainer").offsetHeight
actualheight=cross_marquee.offsetHeight
if (window.opera || navigator.userAgent.indexOf("Netscape/7")!=-1){ //if Opera or Netscape 7x, add scrollbars to scroll and exit
cross_marquee.style.height=marqueeheight+"px"
cross_marquee.style.overflow="scroll"
return
}
setTimeout('lefttime=setInterval("scrollmarquee()",30)', delayb4scroll)
}

//if (window.addEventListener)
//window.addEventListener("load", initializemarquee, false)
//else if (window.attachEvent)
//window.attachEvent("onload", initializemarquee)
//else if (document.getElementById)
//window.onload=initializemarquee

